package describer

import (
    "eruhs/core/parser"
    "fmt"
)

type ARPDescriber struct {
    ARP *parser.ARP
}

func (a *ARPDescriber) GetHeader() []byte {
    return a.ARP.Header
}

func (a *ARPDescriber) GetDetailDescribe() Describe {
    return Describe{
        1: {"硬件类型", fmt.Sprintf("%d", a.ARP.HardwareType)},
        2: {"协议类型", fmt.Sprintf("%d", a.ARP.ProtoType)},
        3: {"硬件地址长度", fmt.Sprintf("%d", a.ARP.HwAddressSize)},
        4: {"协议地址长度", fmt.Sprintf("%d", a.ARP.ProtoAddrSize)},
        5: {"操作码", fmt.Sprintf("%d", a.ARP.Opcode)},
        6: {"源硬件地址", a.ARP.SrcHwAddress.String()},
        7: {"源协议地址", a.ARP.SrcProtoAddress.String()},
        8: {"目标硬件地址", a.ARP.DstHwAddress.String()},
        9: {"目标协议地址", a.ARP.DstProtoAddress.String()},
    }
}
