package describer

import (
    "eruhs/core/parser"
    "fmt"
)

type UDPDescriber struct {
    UDP *parser.UDP
}

func (u *UDPDescriber) GetHeader() []byte {
    return u.UDP.Header
}

func (u *UDPDescriber) GetDetailDescribe() Describe {
    return Describe{
        1: {"源端口(0为无)", fmt.Sprintf("%d", u.UDP.SrcPort)},
        2: {"目标端口", fmt.Sprintf("%d", u.UDP.DstPort)},
        3: {"数据包总长", fmt.Sprintf("%d", u.UDP.Length)},
        4: {"校验和(0为无)", fmt.Sprintf("%d", u.UDP.Checksum)},
    }
}
